#!/bin/sh
#
# This script starts Linux driver installation
#
DIR=/Sentinel
DESTINATION=/usr/src/linux

trap ":" 0 1 2 3

# Installing the Sentinel System Driver
version=`uname -r` 
uname -r | grep "2.0." > /dev/null 2>&1
if [ $? = 0 ]
then
   opt=63
   version=v2.0
else
  if [ "$version" = "1.0" ]
  then
    opt=29
    version=v1.0
  else
    opt=63
    version=v1.2
  fi
fi

uname -r | grep "2.2." > /dev/null 2>&1
if [ $? = 0 ]
then
   opt=63
   version=v2.2
fi

CreateDev() { #create rainbow devices
   set 0 1 2 3
   for i in rnbodrv0 rnbodrv1 rnbodrv2 rnbodrv3;do
   (cd /dev; mknod $i- c $opt $1; chown root:sys $i-; chmod 666 $i-; mv $i- $i)
   shift
   done
}

   echo "Install loadable Sentinel System Driver"

   if [ ! -f /etc/rc.d/rc.local ]
   then
      echo "#!/bin/sh" > /etc/rc.d/rc.local
      chmod 755 /etc/rc.d/rc.local
      chown root root /etc/rc.d/rc.local
   fi
   mv $DIR/$version/mdrbdr.o /boot/. > /dev/null 2>&1
   grep mdrbdr.o /etc/rc.d/rc.local > /dev/null 2>&1
   if [ $? != 0 ]
   then
      cp /etc/rc.d/rc.local /etc/rc.d/rc.local.old > /dev/null 2>&1
      echo "# Sentinel System Driver" >> /etc/rc.d/rc.local
      echo "/sbin/insmod -f /boot/mdrbdr.o" >> /etc/rc.d/rc.local
   fi
   insmod -f /boot/mdrbdr.o > /dev/null 2>&1
   if [ $? != 0 ]
   then
      rmmod mdrbdr > /dev/null 2>&1
      insmod -f /boot/mdrbdr.o
      if [ $? != 0 ]
      then
         echo "Cannot load driver. Installation failed."
         exit 1
      fi
    fi
   CreateDev
   echo "Loadable Driver installation was successful."
   rm -rf /Sentinel/v1.2 > /dev/null 2>&1
   rm -rf /Sentinel/v2.0 > /dev/null 2>&1
   rm -rf /Sentinel/v2.2 > /dev/null 2>&1
   rm -f /Sentinel/setup.sh > /dev/null 2>&1
   rmdir /Sentinel > /dev/null 2>&1
   exit 0

